     .data
ins: .asciz "¡Hola, mundo!"
     .balign 4
nc:  .space 4

     .text
/* 
 Nuestros programas serán funciones invocadas desde el 
 punto de entrada de un programa escrito para Raspbian.
----------------------------------------------------------------*/
     .code  16      @ Esta directiva indica que usaremos Thumb
     .align 2       @ Las instrucciones de Thumb son de 16 bits 
                    @ (alineadas en fronteras de 2 bytes)
mi_programa:
    ldr r0,=ins     @ dirección cadena de entrada
    eor r1, r1, r1  @ contador a 0
loop: 
    ldrb r2, [r0]
    cmp r2, # 0
    beq endc

    add r1, r1, #1  @ contador de incrementos
    add r0, r0, #1  @ puntero de incremento
    b loop

endc: 
    ldr r0, =nc
    str r1, [r0]    @ almacenamos el resultado
	                @ Volver a main. 
    bx lr           @ Esta instrucción sustituye a wfi en QtARMSim
/*----------------------------------------------------------------
 Aquí estaría el punto de entrada desde el SO: una función llamada 
 "main", declarada obligatoriamente como main
*/
    .code 32        @ Indicamos que nuestro código es ARM completo
    .align 4        @ Instrucciones alineadas a 32 bits
    .global main
main:
    push {lr}       @ Apilamos el registro de enlace lr
 
    blx mi_programa @ Utilizamos blx para conmutar de ARM a Thumb al
                    @ al pasar el control a nuestro programa
    pop {lr}        @ Recuperamos el registro de enlace
    bx lr           @ y devolvemos el control al SO
   .end